HelpBot Assistant

How can I help you?

Getting Started

Before we start with the Ribbon, please refer this page page for general information regarding integrating Syncfusion widget’s.

Adding JavaScript and CSS references

To render the Ribbon control, the following list of external dependencies are needed,

  • jQuery - 1.7.1 and later versions
  • Angular - Angular latest versions

The other required internal dependencies are tabulated below,

Files Description/Usage
ej.core.min.js Must always be referred to before using all the JS controls.
ej.data.min.js Used to handle data manger operation and should be used while binding data to JS controls.
ej.globalize.min.js Must be referred to localize any of the JS control's text and content.
ej.ribbon.min.js Should be referred when using Ribbon control.
ej.waitingpopup.min.js This file is used to render waiting popup when on-demand functionality is enabled in Ribbon control.
ej.menu.min.js This file is used to render menu in the application tab.
ej.scroller.min.js This file is used to render scroller in the Ribbon control.
ej.checkbox.min.js This file is used to render checkboxes in the Ribbon control.
ej.tab.min.js This file is used to render tabs into the Ribbon control.
ej.dropdownlist.min.js These files are used to render button,split button,toggle button, and dropdown list controls in the ribbon groups.
ej.splitbutton.min.js
ej.button.min.js
ej.togglebutton.min.js

NOTE

Ribbon uses one or more sub-controls, therefore refer the ej.web.all.min.js (which encapsulates all the ej controls and frameworks in a single file) in the application instead of referring all the above specified internal dependencies.

To get the real appearance of the Ribbon, the dependent CSS file ej.web.all.min.css (which includes styles of all the widgets) should also needs to be referred.

Script/CSS Reference

Create a new HTML file and include the below initial code.

  • HTML
  • <html>
        <head>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="description" content="Essential Studio for JavaScript">
        <meta name="author" content="Syncfusion">
        <title></title>
    
        <!-- Essential Studio for JavaScript  theme reference -->
        <link rel="stylesheet" href="http://cdn.syncfusion.com/32.2.3/js/web/flat-azure/
        ej.web.all.min.css" />
    
        <!-- Angular related script references -->
        <!-- 1. Load libraries -->
             <!-- Polyfill(s) for older browsers -->
        <script src="node_modules/core-js/client/shim.min.js"></script>   
        <script src="node_modules/zone.js/dist/zone.js"></script>
        <script src="node_modules/reflect-metadata/Reflect.js"></script>
        <script src="node_modules/systemjs/dist/system.src.js"></script>
    
        <!-- Essential Studio for JavaScript  script references -->
        <script src="https://code.jquery.com/jquery-1.10.2.min.js">
        </script>
        <script src="http://cdn.syncfusion.com/js/assets/external/jquery.easing.1.3.min.js"> </script>
        <script src="http://cdn.syncfusion.com/js/assets/external/jsrender.min.js"></script>
        <script src="http://cdn.syncfusion.com/32.2.3/js/web/ej.web.all.min.js"> </script> 
        <script src="http://cdn.syncfusion.com/32.2.3/js/common/ej.angular2.min.js"></script>
        
        <!-- 2. Configure SystemJS -->
        <script src="systemjs.config.js"></script>
        <script>       
          System.import('app')
                .then(null, console.error.bind(console));
        </script>
    
        </head>
        <!-- 3. Display the application -->
        <body>
        <my-app>Loading...</my-app>
        </body>
        </html>

    NOTE

    Uncompressed version of library files are also available which is used for development or debugging purpose and can be generated from the custom script here.

    Control Initialization

    Ribbon can be initialized with ‘Application Tab’ and UL list is needed for binding menu to application menu which can be specified through ‘applicationTab.menuItemID’ which denotes ‘id’ of UL.

    Define the Application Tab with ‘applicationTab-type’ as ‘menu’ to render simple Ribbon control.

  • HTML
  • <ej-ribbon id="Default" width="100%" applicationTab.type="menu" 
    applicationTab.menuItemID="menu">
    </ej-ribbon>
    
    <style type="text/css">
        .e-designtablestyle label {
            font-weight: normal;
            font-size: 12px;
            margin-left: 5px;
        }
    </style>	  
         <ul id="menu">
            <li><a>FILE</a>
                <ul>
                    <li><a>New</a></li>
                    <li><a>Open</a></li>
                    <li><a>Save</a></li>
                    <li><a>Print</a></li>
                </ul>
            </li>
       </ul>
  • JS
  • import {Component} from '@angular/core';
    import {NorthwindService} from '../../services/northwind.service';
    
    @Component({
      selector: 'ej-app',
      templateUrl: 'app/components/ribbon/ribbon.component.html',
      providers: [NorthwindService]
    })
    export class RibbonComponent {
       constructor(public northwindService: NorthwindService) {}     
    }

    Ribbon component

    Adding Tabs

    Tab is a set of related groups which are combined into single item. For creating Tab, ‘id’ and ‘text’ properties should be specified.

  • HTML
  • <ej-ribbon id="Default" width="100%" applicationTab.type="menu" 
    applicationTab.menuItemID="menu">
        <e-tabs>
            <e-tab id="home1" text="HOME">
            </e-tab>
        </e-tabs>
    </ej-ribbon>
    <style type="text/css">
        .e-designtablestyle label {
            font-weight: normal;
            font-size: 12px;
            margin-left: 5px;
        }
    </style>	  
         <ul id="menu">
            <li><a>FILE</a>
                <ul>
                    <li><a>New</a></li>
                    <li><a>Open</a></li>
                    <li><a>Save</a></li>
                    <li><a>Print</a></li>
                </ul>
            </li>
       </ul>
  • HTML
  • import {Component} from '@angular/core';
    import {NorthwindService} from '../../services/northwind.service';
    
    @Component({
      selector: 'ej-app',
      templateUrl: 'app/components/ribbon/ribbon.component.html',
      providers: [NorthwindService]
    })
    export class RibbonComponent {
        constructor(public northwindService: NorthwindService) {}
    }

    Ribbon component

    Configuring Groups

    List of controls are combined as logical ‘groups’ into Tab. Group alignment type as ‘row/column’, Default is ‘row’.

    Create group item with ‘text’ specified and add content group to Groups collection with ejButton control settings.

  • HTML
  • <ej-ribbon id="Default" width="100%" applicationTab.type="menu" 
    applicationTab.menuItemID="menu">
       <e-tabs>
            <e-tab id="home1" text="HOME" [groups]="groups1">
            </e-tab>
        </e-tabs>
    </ej-ribbon>
    <style type="text/css">
        .e-designtablestyle label {
            font-weight: normal;
            font-size: 12px;
            margin-left: 5px;
        }
    </style>	  
         <ul id="menu">
            <li><a>FILE</a>
                <ul>
                    <li><a>New</a></li>
                    <li><a>Open</a></li>
                    <li><a>Save</a></li>
                    <li><a>Print</a></li>
                </ul>
            </li>
       </ul>
  • HTML
  • import {Component} from '@angular/core';
    import {NorthwindService} from '../../services/northwind.service';
    
    @Component({
      selector: 'ej-app',
      templateUrl: 'app/components/ribbon/ribbon.component.html',
      providers: [NorthwindService]
    })
    export class RibbonComponent {
        constructor(public northwindService: NorthwindService) {}
         defaults={type:"button",width:"60",height:"70"};
         buttonSettings={ contentType:"imageonly",imagePosition:"imagetop",
         prefixIcon:"e-ribbon e-icon e-new"};
           var font = [{value: 1,text: "Segoe UI" }, {value: 2, text: "Arial"}];
         groups1 = [{ text: "New", alignType: "rows", content: [{ groups: [{id:"new",text:"New",
         toolTip: "New",buttonSettings:{contentType:"imageonly",imagePosition:"imagetop",
         prefixIcon:"e-ribbon e-icon e-new"}}], defaults: { type: "button", width: "50",height:"70",
          isBig: "true" }} ] },{ text: "Clipboard", alignType: "columns",enableGroupExpander:"true",
           content: [{ 
             groups: [{id:"paste",text:"Paste",toolTip: "Paste",buttonSettings:{contentType:"imageonly",
             imagePosition:"imagetop",prefixIcon:"e-ribbon e-icon e-ribbonpaste"}}], 
             defaults: { type: "button", width: "50",height:"70", isBig: "true" }}, { groups: [{ id: "font", 
             dropdownSettings: { dataSource: "font", text: "Segoe UI", width: "150"}}]}  ] }, 
         ];
         
    }

    Ribbon component

    User Interface

    Ribbon component able to integrate any custom components and customized their functionality in application end. Our Ribbon component is similar to Microsoft products(Word). The Ribbon UI consists of several sections like Application Tab, Quick Access Toolbar, Tab, Contextual Tab, Gallery and etc.The following screenshot shows the diagrammatic detail of Ribbon UI:

    Ribbon component

    From above screenshot, you can see Ribbon has several subcomponents for different functionalities. The upcoming sections explains the brief details of each functionalities and their customizations.

HelpBot Assistant

How can I help you?

Getting Started with ReactJS Ribbon

This section explains briefly how to create a Ribbon.

Script & CSS Reference

The Ribbon control has the following list of external JavaScript dependencies.

  • jQuery 1.7.1 and later versions

The required ReactJS script dependencies as follows. And you can also refer React to know more about react js.

To translate JSX to plain JavaScript, we must use <script type=”text/babel”> and refer the browser.min.js file to perform the transformation in the browser.

To get started, you can use the ej.web.all.min.js file that encapsulates all the ej controls and frameworks in one single file. So the complete boilerplate code is

  • HTML
  • <!DOCTYPE html>
        <html>
        <head>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="description" content="Essential Studio for JavaScript">
        <meta name="author" content="Syncfusion">
        <title>Getting Started for Ribbon React JS</title>
        <!-- Essential Studio for JavaScript  theme reference -->
        <link href="http://cdn.syncfusion.com/32.2.3/js/web/flat-azure/ej.web.all.min.css" rel="stylesheet" />
        <!-- Essential Studio for JavaScript  script references -->
        <script src="http://cdn.syncfusion.com/js/assets/external/react.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/react-dom.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-core/5.8.34/browser.min.js"></script>
        <script src="http://cdn.syncfusion.com/js/assets/external/jquery-3.0.0.min.js"></script>
        <script src="http://cdn.syncfusion.com/32.2.3/js/web/ej.web.all.min.js"></script>
        <script src="http://cdn.syncfusion.com/32.2.3/js/common/ej.web.react.min.js"></script>
        <!-- Add your custom scripts here -->
        </head>
        <body>
        </body>
        </html>

    NOTE

    1. In production, we highly recommend you to use our custom script generator to create custom script file with required controls and its dependencies only. Also to reduce the file size further please use GZip compression in your server.
    2. For themes, you can use the ej.web.all.min.css CDN link from the code snippet given. To add the themes in your application, please refer to this link.

    NOTE

    Ribbon’s sample level icons can be loaded using ej.icons.CSS from the location “/Content/ej/themes/ribbon-css”.

    Control Initialization

    Control can be initialized in two ways.

    • Using jsx Template
    • Without using jsx Template

    Using jsx Template

    By using the jsx template, we can create the html file and jsx file. The .jsx file can be convert to .js file and it can be referred in html page.

    Please refer to the code of HTML file.

  • HTML
  • <div id="ribbon-default"></div>
        <script src="app/ribbon/default.js"></script>
        <ul id="ribbonmenu1">
            <li><a>FILE</a>
                <ul>
                    <li><a>New</a></li>
                    <li><a>Open</a></li>
                    <li><a>Save</a></li>
                    <li><a>Save As</a></li>
                    <li><a>Print</a></li>
                </ul>
            </li>
        </ul>

    Ribbon control can be initialized with the following in HTML document.

  • HTML
  • ReactDOM.render(
            <EJ.Ribbon width="50%" applicationTab-type="menu" applicationTab-menuItemID="ribbonmenu1">
            </EJ.Ribbon>,
            document.getElementById('ribbon-default')
        );

    ribbon

    NOTE

    Set the required width to Ribbon, else default parent container or window width will be considered.

    Adding Tabs

    Tab is a set of related groups which are combined into single item. For creating tab, id and text properties should be specified.

  • HTML
  • <div id="ribbon-default"></div>
        <script src="app/ribbon/default.js"></script>
        <ul id="ribbonmenu1">
            <li><a>FILE</a>
                <ul>
                    <li><a>New</a></li>
                    <li><a>Open</a></li>
                    <li><a>Save</a></li>
                    <li><a>Save As</a></li>
                    <li><a>Print</a></li>
                </ul>
            </li>
        </ul>

    Configure the tabs bind value tab in ReactJS view-model as shown in the following code.

  • HTML
  • ReactDOM.render(
            <EJ.Ribbon width="50%" applicationtab-type="menu" applicationtab-menuitemid="ribbonmenu1">
                <tabs>
                    <tab id="home" text="HOME"></tab>
                </tabs>
            </EJ.Ribbon>
            document.getElementById('ribbon-default')
         );

    tabs

    Configuring Groups

    List of controls are combined as logical groups into tab. Group alignment type as row/column, Default is row.

    Create group item with text specified and add content group to Groups collection with ejButton control settings.

    Configure the tabs bind value tab with group and button named as New.

  • HTML
  • <div id="ribbon-default"></div>
        <script src="app/ribbon/default.js"></script>
        <ul id="ribbonmenu1">
            <li><a>FILE</a>
                <ul>
                    <li><a>New</a></li>
                    <li><a>Open</a></li>
                    <li><a>Save</a></li>
                    <li><a>Save As</a></li>
                    <li><a>Print</a></li>
                </ul>
            </li>
        </ul>
  • HTML
  • ReactDOM.render(
            <EJ.Ribbon width="50%" applicationtab-type="menu" applicationtab-menuitemid="ribbonmenu1">
                <tabs>
                    <tab id="home" text="HOME">
                        <groups>
                            <group text="New" alignType="rows">
                                <content>
                                    <content defaults-type="button">
                                        <groups>
                                            <group id="new" text="New" buttonSettings-contentType="imageonly" buttonSettings-prefixIcon="e-icon e-ribbon e-new" >
                                            </group>
                                        </groups>
                                    </content>
                                </content>
                            </group>
                        </groups>
                    </tab>
                </tabs>
            </EJ.Ribbon>
            document.getElementById('ribbon-default')
         );

    ribbon

    Adding Controls to Group

    Syncfusion JavaScript Controls can be added to group’s content with corresponding type specified like button, split button, toggle button, dropdown list, gallery, custom, etc. Default type is button.

    Configure the tabs bind value tab with groups, button,split button and dropdown controls.Also the datasource to dropdown control is configured with bind name fontFamily. Please refer to the following code snippets.

  • HTML
  • var fontFamily = ["Segoe UI", "Arial", "Times New Roman", "Tahoma", "Helvetica"];
         ReactDOM.render(
         <div>
             <ul id="ribbonmenu3">
                 <li><a>FILE</a>
                     <ul>
                         <li><a>New</a></li>
                         <li><a>Open</a></li>
                         <li><a>Save</a></li>
                         <li><a>Save As</a></li>
                         <li><a>Print</a></li>
                     </ul>
                 </li>
             </ul>
             <ul id="pasteSplit3">
                 <li><a>Paste</a></li>
             </ul>
             <EJ.Ribbon width="100%" applicationtab-type="menu" applicationtab-menuitemid="ribbonmenu3">
                <tabs>
                    <tab id="home" text="HOME">
                        <groups>		     
                            <group text="SplitButton & Dropdown" alignType="columns">
                                <content>
                                    <content defaults-type="splitbutton" defaults-width={60} defaults-height={70}>
                                        <groups>
                                            <group id="paste" text="Paste" customTooltip-prefixIcon="e-pastetip" splitButtonSettings-contentType="imageonly" splitButtonSettings-prefixIcon="e-icon e-ribbon e-ribbonpaste" splitButtonSettings-targetID="pasteSplit3" splitButtonSettings-buttonMode="dropdown" splitButtonSettings-arrowPosition="bottom" splitButtonSettings-click="executeAction">
                                            </group>
                                        </groups>
                                    </content>
                                    <content defaults-type="dropdownlist" defaults-height={28}>
                                        <groups>
                                            <group id="fontFamily" dropdownSettings-dataSource={fontFamily} dropdownSettings-text="Segoe UI" dropdownSettings-select="executeAction" dropdownSettings-width={150}>
                                            </group>    
                                        </groups>
                                    </content>
                                </content>
                            </group>
                        </groups>  
                    </tab>		
                </tabs>
             </EJ.Ribbon>
         </div>
         document.getElementById('ribbon-default')
         );

    Controls

    Without using jsx Template

    The Ribbon can be created from a HTML DIV element with the HTML id attribute set to it. Refer to the following code example.

  • HTML
  • <body>
    	  <div id="ribbon-default"></div>
          <ul id="ribbonmenu3">
                 <li><a>FILE</a>
                     <ul>
                         <li><a>New</a></li>
                         <li><a>Open</a></li>
                         <li><a>Save</a></li>
                         <li><a>Save As</a></li>
                         <li><a>Print</a></li>
                     </ul>
                 </li>
             </ul>
             <ul id="pasteSplit3">
                 <li><a>Paste</a></li>
             </ul>
     	  </body>
  • HTML
  • var fontFamily = ["Segoe UI", "Arial", "Times New Roman", "Tahoma", "Helvetica"];     
        React.createElement(EJ.Ribbon, {width: "100%", allowResizing: true, "applicationTab-type": "menu", "applicationTab-menuItemID": "ribbonmenu3"}, 
          React.createElement("tabs", null, 
            React.createElement("tab", {id: "home", text: "HOME"}, 
               React.createElement("groups", null,		     
    			  React.createElement("group", {text: "SplitButton & Dropdown", alignType: "columns"}, 
                    React.createElement("content", null, 
                        React.createElement("content", {"defaults-type": "splitbutton", "defaults-width": 60, "defaults-height": 70}, 
                           React.createElement("groups", null, 
                               React.createElement("group", {id: "paste", text: "Paste", "customTooltip-prefixIcon": "e-pastetip", "splitButtonSettings-contentType": "imageonly", "splitButtonSettings-prefixIcon": "e-icon e-ribbon e-ribbonpaste", "splitButtonSettings-targetID": "pasteSplit3", "splitButtonSettings-buttonMode": "dropdown", "splitButtonSettings-arrowPosition": "bottom", "splitButtonSettings-click": "executeAction"}
                               )
                            )
                          ), 
    					React.createElement("content", {"defaults-type": "dropdownlist", "defaults-height": 28}, 
                           React.createElement("groups", null, 
                               React.createElement("group", {id: "fontFamily", "dropdownSettings-dataSource": fontFamily, "dropdownSettings-text": "Segoe UI", "dropdownSettings-select": "executeAction", "dropdownSettings-width": 150})
                                )
                            )
                        )
    				)
                )		
            )
          )
        ),
        document.getElementById('ribbon-default')
        );

    Without JSX